/* Generated by MyraPad at 05.01.2022 21:42:44 */

using Microsoft.Xna.Framework;

using MonoPanda.Configuration;
using MonoPanda.Content;
using MonoPanda.Spine.MonoPanda;
using MonoPanda.UserSettings;
using MonoPanda.Utils;

using Myra.Graphics2D.Brushes;
using Myra.Graphics2D.UI;
using Myra.Graphics2D.UI.ColorPicker;
using Myra.Graphics2D.UI.File;

using System;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

using TextBox = Myra.Graphics2D.UI.TextBox;

namespace SkinManager {
  public partial class UI {
    private MainState mainState;

    private String importFileFilter;

    public UI(MainState mainState) {
      this.mainState = mainState;
      BuildUI();

      initSpineAssetsComboBox();
      initExternalSkinsList();
      initEnableSkinButton();
      initCoreSkinsList();
      initEnableCoreSkinButton();
      initSideComboBox();
      initAnimationComboBox();
      initColorChannelsList();
      initColorPickerButton();
      initPropertiesGrid();
      initAttachmentComboBox();
      initXSpinButton();
      initYSpinButton();
      initRotationSpinButton();
      initWidthSpinButton();
      initHeightSpinButton();
      initScaleXSpinButton();
      initScaleYSpinButton();
      initMeshSkinComboBox();
      initSaveButton();
      initRemoveSkinButton();
      initImportSkinButton();
      initSkinManagerTab();
      initContentItemPropertiesGrid();
      initContentItemsList();
      initContentItemItemTypeComboBox();
      initSaveContentItemButton();
      initContentItemPathTextButton();
      initRemoveContentItemButton();
      initMainFileLocationLabel();
      initSaveLocationLabel();
      initContentItemImportSavePathTextBox();
      initContentItemImportSavePathTextButton();
      initContentItemImportPathTextBox();
      initContentItemImportPathTextButton();
      initContentItemImportItemTypeComboBox();
      initContentItemImportIdTextBox();
      initImportContentItemButton();
      initSkinManagerSettings();
      initProjectSettings();
      initProjectPathLabel();
      initOpenProjectTextButton();
      initActiveModComboBox();
    }

    private void refreshUI() {
      //refreshSpineAssetsComboBox();
      refreshAnimationComboBox();
      refreshCoreSkinsList();
      refreshExternalSkinsList();
      refreshSideComboBox();
      refreshColorChannelsList();
      refreshPropertiesGrid();
      refreshAttachmentComboBox();
      refreshContentItemPropertiesGrid();
      refreshContentItemsList();
      refreshMainFileLocationLabel();
      refreshSaveLocationLabel();
      refreshContentItemImportSavePathTextBox();
      refreshContentItemImportSavePathTextButton();
      refreshContentItemImportPathTextBox();
      refreshContentItemImportPathTextButton();
      refreshContentItemImportItemTypeComboBox();
      refreshContentItemImportIdTextBox();
      refreshImportContentItemButton();
      refreshSkinManagerSettings();
      refreshProjectSettings();
      refreshProjectPathLabel();
    }

    private void initSpineAssetsComboBox() {
      refreshSpineAssetsComboBox();
      SpineAssetsComboBox.SelectedIndexChanged += spineAssetsComboBoxValueChanged;
      SpineAssetsComboBox.SelectedIndexChanged += (sender, args) => {
        refreshUI();
      };
      SpineAssetsComboBox.SelectedIndex = 0;
    }

    private void refreshSpineAssetsComboBox() {
      SpineAssetsComboBox.Items.Clear();
      foreach (var contentItem in Project.GetSpineAssets()) {
        ListItem listItem = new ListItem(contentItem.Id, Color.White);
        SpineAssetsComboBox.Items.Add(listItem);
      }
    }

    private void spineAssetsComboBoxValueChanged(object? sender, EventArgs eventArgs) {
      if (SpineAssetsComboBox.SelectedItem != null) {
        Project.OpenSpineProject(SpineAssetsComboBox.SelectedItem.Text);
        mainState.RefreshEntity();
      }
    }

    private void initExternalSkinsList() {
      refreshExternalSkinsList();
      ExternalSkinsList.TouchDoubleClick += (sender, args) => {
        toggleSkin(ExternalSkinsList.SelectedItem);
      };

      ExternalSkinsList.SelectedIndexChanged += (sender, args) => {
        fillAttachmentComboBox();
      };
    }

    private void refreshExternalSkinsList() {
      ExternalSkinsList.Items.Clear();
      foreach (var externalSkin in Project.GetWorkingExternalSkins()) {
        ListItem listItem = new ListItem(externalSkin.Name, Color.White, externalSkin.Name);
        ExternalSkinsList.Items.Add(listItem);
      }
    }

    private void initEnableSkinButton() {
      EnableSkinButton.TouchDown += (sender, args) => {
        ListItem selectedSkinItem = ExternalSkinsList.SelectedItem;
        toggleSkin(selectedSkinItem);
      };
    }

    private void initCoreSkinsList() {
      refreshCoreSkinsList();
      CoreSkinsList.TouchDoubleClick += (sender, args) => {
        toggleSkin(CoreSkinsList.SelectedItem);
      };
    }

    private void refreshCoreSkinsList() {
      CoreSkinsList.Items.Clear();
      foreach (var coreSkin in Project.GetCoreSkins()) {
        ListItem listItem = new ListItem(coreSkin.Name, Color.White, coreSkin.Name);
        CoreSkinsList.Items.Add(listItem);
      }
    }

    public void EnableCoreSkin(string skinName) {
      foreach (var item in CoreSkinsList.Items) {
        if (item.Text.Equals(skinName)) {
          toggleSkin(item);
        }
      }
    }

    private void initEnableCoreSkinButton() {
      EnableCoreSkinButton.TouchDown += (sender, args) => {
        ListItem selectedSkinItem = CoreSkinsList.SelectedItem;
        toggleSkin(selectedSkinItem);
      };
    }

    private void toggleSkin(ListItem skinListItem) {
      if (skinListItem == null) {
        return;
      }

      if (skinListItem.Color != Color.Aquamarine) {
        skinListItem.Color = Color.Aquamarine;
        mainState.EnableSkin(skinListItem.Text);
      } else {
        skinListItem.Color = Color.White;
        mainState.DisableSkin(skinListItem.Text);
      }
    }

    private void initSideComboBox() {
      refreshSideComboBox();
      SideComboBox.SelectedIndexChanged += (sender, args) => {
        if (SideComboBox.SelectedItem != null) {
          mainState.ChangeSide(SideComboBox.SelectedItem.Text);
        }
      };
      SideComboBox.SelectedIndex = 0;
    }

    private void refreshSideComboBox() {
      SideComboBox.Items.Clear();
      foreach (var availableSide in Project.ProjectConfig.AvailableSidePrefixes.Split(",")) {
        ListItem availableSideItem = new ListItem(availableSide);
        SideComboBox.Items.Add(availableSideItem);
      }

      SideComboBox.SelectedIndex = 0;
    }

    private void initAnimationComboBox() {
      refreshAnimationComboBox();
      AnimationComboBox.SelectedIndexChanged += (sender, args) => {
        if (AnimationComboBox.SelectedItem != null) {
          mainState.PlayAnimation(AnimationComboBox.SelectedItem.Text);
        }
      };
      AnimationComboBox.SelectedIndex = 0;
    }

    private void refreshAnimationComboBox() {
      AnimationComboBox.Items.Clear();
      foreach (var animation in Project.GetAnimations()) {
        ListItem animationItem = new ListItem(animation.Name);
        AnimationComboBox.Items.Add(animationItem);
      }
    }

    private void initColorChannelsList() {
      refreshColorChannelsList();
      ColorChannelsList.SelectedIndexChanged += (sender, args) => {
        if (ColorChannelsList.SelectedItem != null) {
          ColorPickerButton.Background = new SolidBrush((Color)ColorChannelsList.SelectedItem.Tag);
        } else {
          ColorPickerButton.Background = new SolidBrush(Color.White);
        }
      };
    }

    private void refreshColorChannelsList() {
      ColorChannelsList.Items.Clear();
      foreach (var colorChannel in Project.ProjectConfig.AvailableColorChannelSuffixes.Split(",")) {
        ListItem colorChannelItem = new ListItem(colorChannel, Color.White, Color.White);
        ColorChannelsList.Items.Add(colorChannelItem);
      }
    }

    private void initColorPickerButton() {
      ColorPickerButton.TouchDown += (sender, args) => {
        if (ColorChannelsList.SelectedItem != null) {
          ColorPickerDialog dialog = new ColorPickerDialog();
          dialog.Color = (Color)ColorChannelsList.SelectedItem.Tag;
          dialog.ShowModal(Desktop);

          dialog.Closed += (o, eventArgs) => {
            if (dialog.Result) {
              ColorChannelsList.SelectedItem.Tag = dialog.Color;
              ColorPickerButton.Background = new SolidBrush(dialog.Color);
              mainState.UpdateColors(ColorChannelsList.SelectedItem.Text, dialog.Color);
            }
          };
        }
      };
    }

    private void initPropertiesGrid() {
      refreshPropertiesGrid();
    }

    private void refreshPropertiesGrid() {
      PropertiesGrid.Visible = false;
    }

    private void initAttachmentComboBox() {
      refreshAttachmentComboBox();

      AttachmentComboBox.SelectedIndexChanged += (sender, args) => {
        if (AttachmentComboBox.SelectedItem != null) {
          PropertiesGrid.Visible = true;
          var externalAttachment = (ExternalAttachment)AttachmentComboBox.SelectedItem.Tag;
          XSpinButton.Value = externalAttachment.X;
          YSpinButton.Value = externalAttachment.Y;
          RotationSpinButton.Value = externalAttachment.Rotation;
          WidthSpinButton.Value = externalAttachment.Width;
          HeightSpinButton.Value = externalAttachment.Height;
          ScaleXSpinButton.Value = externalAttachment.ScaleX;
          ScaleYSpinButton.Value = externalAttachment.ScaleY;
          fillMeshSkinComboBox();
        } else {
          PropertiesGrid.Visible = false;
        }
      };
    }

    private void refreshMeshSkinComboBox() {
      MeshSkinComboBox.Items.Clear();
    }

    private void fillMeshSkinComboBox() {
      refreshMeshSkinComboBox();

      ListItem empty = new ListItem("---------", Color.Yellow, null);
      MeshSkinComboBox.Items.Add(empty);

      int activeIndex = 0;
      foreach (var coreSkin in Project.GetCoreSkins()) {
        ListItem listItem = new ListItem(coreSkin.Name, Color.White, coreSkin.Name);
        MeshSkinComboBox.Items.Add(listItem);

        var externalAttachment = (ExternalAttachment)AttachmentComboBox.SelectedItem.Tag;
        if (coreSkin.Name.Equals(externalAttachment.MeshSkinName)) {
          activeIndex = MeshSkinComboBox.Items.Count - 1;
        }
      }

      MeshSkinComboBox.SelectedIndex = activeIndex;
    }

    private void refreshAttachmentComboBox() {
      AttachmentComboBox.Items.Clear();
    }

    private void fillAttachmentComboBox() {
      refreshAttachmentComboBox();
      if (ExternalSkinsList.SelectedItem != null) {
        foreach (var attachment in Project.GetWorkingExternalSkins()
          .Find(skin => skin.Name.Equals(ExternalSkinsList.SelectedItem.Text)).Attachments) {
          ListItem listItem = new ListItem(attachment.SlotName, Color.White, attachment);
          AttachmentComboBox.Items.Add(listItem);
        }
      }
    }

    private void refreshSkins() {
      Project.RefreshSkinsInContentManager();
    }

    private bool validateValueFloat(string newValue, TextBox textBox) {
      var isFloat = float.TryParse(newValue, out float f);

      if (!isFloat) {
        textBox.Border = new SolidBrush(Color.Red);
        return false;
      }

      textBox.Border = new SolidBrush(Color.Transparent);
      return true;
    }

    private void initXSpinButton() {
      XSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).X = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initYSpinButton() {
      YSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).Y = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initRotationSpinButton() {
      RotationSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).Rotation = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initWidthSpinButton() {
      WidthSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).Width = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initHeightSpinButton() {
      HeightSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).Height = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initScaleXSpinButton() {
      ScaleXSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).ScaleX = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initScaleYSpinButton() {
      ScaleYSpinButton.ValueChanging += (sender, args) => {
        if (args.NewValue != null)
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).ScaleY = args.NewValue.Value;
        refreshSkins();
      };
    }

    private void initSaveButton() {
      SaveButton.TouchDown += (sender, args) => {
        Project.Save();
      };
    }

    private void initMeshSkinComboBox() {
      MeshSkinComboBox.SelectedIndexChanged += (sender, args) => {
        if (MeshSkinComboBox.SelectedItem != null) {
          ((ExternalAttachment)AttachmentComboBox.SelectedItem.Tag).MeshSkinName =
            MeshSkinComboBox.SelectedIndex > 0 ? MeshSkinComboBox.SelectedItem.Text : null;
          refreshSkins();
        }
      };
    }

    private void initRemoveSkinButton() {
      RemoveSkinButton.TouchDown += (sender, args) => {
        if (ExternalSkinsList.SelectedItem != null) {
          if (Project.GetContentItems().Find((c) => c.Id.Equals(ExternalSkinsList.SelectedItem.Text)) != null) {
            var dialog = new Window();
            dialog.Title = "Remove with content item?";
            var grid = new Grid();
            var removeWithContentButton = new TextButton {
              Text = "Remove with content item", GridColumn = 1
            };
            var justRemoveButton = new TextButton {
              Text = "Just remove skin", GridColumn = 3
            };
            grid.AddChild(removeWithContentButton);
            grid.AddChild(justRemoveButton);
            dialog.Content = grid;
            dialog.ShowModal(Desktop);
            justRemoveButton.TouchUp += (o, eventArgs) => {
              removeExternalSkin(ExternalSkinsList.SelectedItem.Text);
              dialog.Close();
            };
            removeWithContentButton.TouchUp += (o, eventArgs) => {
              removeContentItem(ExternalSkinsList.SelectedItem.Text);
              removeExternalSkin(ExternalSkinsList.SelectedItem.Text);
              dialog.Close();
            };
          } else {
            removeExternalSkin(ExternalSkinsList.SelectedItem.Text);
          }
        }
      };
    }

    private void removeContentItem(string id) {
      Project.RemoveContentItem(id);
    }

    private void removeExternalSkin(string skinName) {
      Project.GetWorkingExternalSkins().RemoveAll(skin => skin.Name.Equals(skinName));
      Project.Save();
      refreshExternalSkinsList();
    }

    private void initImportSkinButton() {
      ImportSkinButton.TouchDown += (sender, args) => {
        var dialog = new FileDialog(FileDialogMode.OpenFile);
        dialog.FilePath = string.IsNullOrEmpty(Settings.SkinManager.AssetsPath)
          ? Project.GetActiveProjectPath()
          : Settings.SkinManager.AssetsPath;
        dialog.Filter = "*.json|*.xcf";
        dialog.Title = "Select project to import";
        dialog.ShowModal(Desktop);

        dialog.Closed += (o, eventArgs) => {
          if (dialog.Result) {
            var saveDialog = new FileDialog(FileDialogMode.ChooseFolder);
            var defaultPath = $"{Project.GetActiveModPath()}/{Project.ProjectConfig.ImportedSkinDefaultLocation}";
            saveDialog.FilePath = Directory.Exists(defaultPath) ? defaultPath : $"{Project.GetActiveModPath()}/";
            saveDialog.Title = "Select folder for imported skin texture (within project)";
            saveDialog.ShowModal(Desktop);

            saveDialog.Closed += (sender1, args1) => {
              if (saveDialog.Result) {
                var processDialog = new Window {
                  Title = "Import in process",
                  CloseButton = {
                    Enabled = false, Visible = false
                  }
                };
                processDialog.ShowModal(Desktop);
                Task.Factory.StartNew(() => {
                  var importSuccess = SkinImporter.ImportFile(dialog.FilePath, saveDialog.Folder);
                  if (importSuccess) {
                    var successDialog = new Window {
                      Title = "Success",
                      Content = new Label {
                        Text = "Skin imported successfully."
                      }
                    };

                    successDialog.CloseButton.TouchDown += (sender1, args1) => {
                      refreshExternalSkinsList();
                      mainState.RefreshEntity();
                    };
                    successDialog.ShowModal(Desktop);
                    processDialog.Close();
                  } else {
                    var failDialog = new Window {
                      Title = "Import failed",
                      Content = new Label {
                        Text = "Skin import failed. Check logs for more information."
                      }
                    };
                    failDialog.ShowModal(Desktop);
                    processDialog.Close();
                  }
                });
              }
            };
          }
        };
      };
    }

    private void initSkinManagerTab() {
      TabControl.SelectedIndexChanged += (sender, args) => {
        updateTabVisibility();
        refreshUI();
      };
      updateTabVisibility();
    }

    private void updateTabVisibility() {
      SkinManagerGrid.Visible = SkinManagerTab.IsSelected;
      TabControl.Height = SkinManagerTab.IsSelected ? 20 : 800;
      mainState.SetEntityVisibility(SkinManagerTab.IsSelected);
      // if (SkinManagerTab.IsSelected) {
      //   refreshUI();
      // }
    }

    private void initContentItemPropertiesGrid() {
      refreshContentItemPropertiesGrid();
    }

    private void refreshContentItemPropertiesGrid() {
      ContentItemPropertiesGrid.Visible = false;
    }

    private void initContentItemsList() {
      refreshContentItemsList();
      ContentItemsList.SelectedIndexChanged += (sender, args) => {
        contentItemSelected();
      };
    }

    private void refreshContentItemsList() {
      ContentItemsList.Items.Clear();
      foreach (var contentItem in Project.GetContentItems()) {
        ListItem listItem = new ListItem(contentItem.Id, Color.White, contentItem);
        ContentItemsList.Items.Add(listItem);
      }
    }

    private void contentItemSelected() {
      if (ContentItemsList.SelectedItem != null) {
        ContentItemPropertiesGrid.Visible = true;
        var contentItem = (ContentItem)ContentItemsList.SelectedItem.Tag;
        ContentItemIdTextBox.Text = contentItem.Id;
        ContentItemPathTextBox.Text = contentItem.FilePath;
        ContentItemNeverUnloadCheckBox.IsChecked = contentItem.NeverUnload;
        ContentItemItemTypeComboBox.SelectedIndex = (int)contentItem.ItemType;
      }
    }

    private void initContentItemItemTypeComboBox() {
      foreach (var val in Enum.GetNames(typeof(ContentItemType))) {
        ContentItemItemTypeComboBox.Items.Add(new ListItem(val));
      }
    }

    private void initSaveContentItemButton() {
      SaveContentItemButton.TouchUp += (sender, args) => {
        var contentItem = (ContentItem)ContentItemsList.SelectedItem.Tag;
        bool changedActiveSpineProject = contentItem.Id.Equals(Project.GetActiveSpineProject());
        contentItem.Id = ContentItemIdTextBox.Text;
        contentItem.FilePath = ContentItemPathTextBox.Text;
        contentItem.NeverUnload = ContentItemNeverUnloadCheckBox.IsChecked;
        contentItem.ItemType = Enum.Parse<ContentItemType>(ContentItemItemTypeComboBox.SelectedItem.Text);
        Project.SaveContentItems();
        if (changedActiveSpineProject) {
          Project.OpenSpineProject(ContentItemIdTextBox.Text);
        }

        var selectedIndex = ContentItemsList.SelectedIndex;
        refreshUI();
        refreshSpineAssetsComboBox();
        ContentItemsList.SelectedIndex = selectedIndex;
      };
    }

    private void initContentItemPathTextButton() {
      ContentItemPathTextButton.TouchUp += (sender, args) => {
        var dialog = new FileDialog(FileDialogMode.OpenFile);
        dialog.Title = "Select content item path";
        dialog.FilePath = getContentItemPathTextBoxOrDefaultPath();
        dialog.ShowModal(Desktop);

        dialog.Closed += (o, eventArgs) => {
          if (dialog.Result) {
            var resultPath = dialog.FilePath;
            if (Utils.IsDirectoryWithinAnother(resultPath, Project.GetActiveModPath())) {
              ContentItemPathTextBox.Text =
                resultPath.Replace("\\", "/").Replace($"{Project.GetActiveModPath()}/", "");
            } else {
              var errorDialog = new Window();
              errorDialog.Title = "File is not inside active mod directory!";
              errorDialog.ShowModal(Desktop);
            }
          }
        };
      };
    }

    private string getContentItemPathTextBoxOrDefaultPath() {
      if (string.IsNullOrEmpty(ContentItemPathTextBox.Text)) {
        return $"{Project.GetActiveProjectPath()}{Project.ModsPath}{Project.ActiveMod}";
      }

      return $"{Project.GetActiveProjectPath()}{Project.ModsPath}{Project.ActiveMod}/{ContentItemPathTextBox.Text}";
    }

    private void initRemoveContentItemButton() {
      RemoveContentItemButton.TouchUp += (sender, args) => {
        var dialog = new Dialog();
        dialog.Title = "Warning! This action will remove content item record and related files! Continue?";
        dialog.ShowModal(Desktop);
        dialog.Closed += (o, eventArgs) => {
          if (dialog.Result) {
            Project.RemoveContentItem(ContentItemsList.SelectedItem.Text);
            refreshUI();
            refreshSpineAssetsComboBox();
          }
        };
      };
    }

    private void initSaveLocationLabel() {
      refreshSaveLocationLabel();
    }

    private void refreshSaveLocationLabel() {
      SaveLocationLabel.Visible = false;
    }

    private void initMainFileLocationLabel() {
      refreshMainFileLocationLabel();
    }

    private void refreshMainFileLocationLabel() {
      MainFileLocationLabel.Visible = false;
    }

    private void initContentItemImportSavePathTextBox() {
      refreshContentItemImportSavePathTextBox();
    }

    private void refreshContentItemImportSavePathTextBox() {
      ContentItemImportSavePathTextBox.Text = "";
      ContentItemImportSavePathTextBox.Visible = false;
    }

    private void initContentItemImportSavePathTextButton() {
      refreshContentItemImportSavePathTextButton();
      ContentItemImportSavePathTextButton.TouchUp += (sender, args) => {
        var dialog = new FileDialog(FileDialogMode.ChooseFolder);
        dialog.Title = "Select location to save";
        dialog.FilePath = getContentItemImportSavePathTextBoxOrDefaultPath();
        dialog.ShowModal(Desktop);

        dialog.Closed += (o, eventArgs) => {
          if (dialog.Result) {
            var resultPath = dialog.FilePath;
            if (Utils.IsDirectoryWithinAnother(resultPath, Project.GetActiveModPath())) {
              ContentItemImportSavePathTextBox.Text =
                resultPath.Replace("\\", "/").Replace($"{Project.GetActiveModPath()}/", "").Replace(Project.GetActiveModPath(), "");
            } else {
              var errorDialog = new Window();
              errorDialog.Title = "File is not inside active mod directory!";
              errorDialog.ShowModal(Desktop);
            }
          }
        };
      };
    }

    private void refreshContentItemImportSavePathTextButton() {
      ContentItemImportSavePathTextButton.Visible = false;
    }

    private string getContentItemImportSavePathTextBoxOrDefaultPath() {
      if (string.IsNullOrEmpty(ContentItemImportSavePathTextBox.Text)) {
        return $"{Project.GetActiveProjectPath()}{Project.ModsPath}{Project.ActiveMod}/";
      }

      return
        $"{Project.GetActiveProjectPath()}{Project.ModsPath}{Project.ActiveMod}/{ContentItemImportSavePathTextBox.Text}/";
    }

    private string getContentItemImportPathTextBoxOrDefaultPath() {
      if (string.IsNullOrEmpty(ContentItemImportPathTextBox.Text)) {
        return string.IsNullOrEmpty(Settings.SkinManager.AssetsPath)
          ? Project.GetActiveProjectPath()
          : Settings.SkinManager.AssetsPath;
      }

      return ContentItemImportPathTextBox.Text;
    }

    private void initContentItemImportPathTextBox() {
      refreshContentItemImportPathTextBox();
    }

    private void refreshContentItemImportPathTextBox() {
      ContentItemImportPathTextBox.Text = "";
      ContentItemImportPathTextBox.Visible = false;
    }

    private void initContentItemImportPathTextButton() {
      refreshContentItemImportPathTextButton();
      ContentItemImportPathTextButton.TouchUp += (sender, args) => {
        var dialog = new FileDialog(FileDialogMode.OpenFile);
        dialog.Title = "Select file to import";
        dialog.FilePath = getContentItemImportPathTextBoxOrDefaultPath();
        dialog.Filter = importFileFilter;
        dialog.ShowModal(Desktop);

        dialog.Closed += (o, eventArgs) => {
          if (dialog.Result) {
            ContentItemImportPathTextBox.Text = dialog.FilePath.Replace("\\", "/");
          }
        };
      };
    }

    private void refreshContentItemImportPathTextButton() {
      ContentItemImportPathTextButton.Visible = false;
    }

    private void initContentItemImportItemTypeComboBox() {
      foreach (var val in Enum.GetNames(typeof(ContentItemType))) {
        ContentItemImportItemTypeComboBox.Items.Add(new ListItem(val));
      }

      ContentItemImportItemTypeComboBox.SelectedIndexChanged += (sender, args) => {
        if (ContentItemImportItemTypeComboBox.SelectedItem == null)
          return;

        ContentItemImportSavePathTextBox.Visible = true;
        ContentItemImportSavePathTextButton.Visible = true;
        SaveLocationLabel.Visible = true;
        MainFileLocationLabel.Visible = true;
        ContentItemImportPathTextBox.Visible = true;
        ContentItemImportPathTextButton.Visible = true;
        ImportContentItemButton.Visible = true;

        switch (Enum.Parse<ContentItemType>(ContentItemImportItemTypeComboBox.SelectedItem.Text)) {
          case ContentItemType.Texture2D:
            MainFileLocationLabel.Text = "File to import [.png]: ";
            importFileFilter = "*.png";
            break;
          case ContentItemType.Song:
            MainFileLocationLabel.Text = "File to import [.ogg]: ";
            importFileFilter = "*.ogg";
            break;
          case ContentItemType.BitmapFont:
            MainFileLocationLabel.Text = "File to import [.fnt]: ";
            importFileFilter = "*.fnt";
            break;
          case ContentItemType.SoundEffect:
            MainFileLocationLabel.Text = "File to import [.wav]: ";
            importFileFilter = "*.wav";
            break;
          case ContentItemType.SpineAsset:
            MainFileLocationLabel.Text = "File to import [.atlas]: ";
            importFileFilter = "*.atlas";
            break;
          case ContentItemType.SpriteSheet:
            MainFileLocationLabel.Text = "File to import [.png]: ";
            importFileFilter = "*.png";
            break;
          case ContentItemType.TiledMap:
            MainFileLocationLabel.Text = "File to import [.json]: ";
            importFileFilter = "*.json";
            break;
        }
      };
    }

    private void refreshContentItemImportItemTypeComboBox() {
      ContentItemImportItemTypeComboBox.SelectedItem = null;
    }

    private void initContentItemImportIdTextBox() {
      ContentItemImportIdTextBox.TextChanged += (sender, args) => {
        if (Project.GetContentItems().Exists(item => item.Id.Equals(args.NewValue))) {
          ContentItemImportIdTextBox.Border = new SolidBrush(Color.Red);
          ImportContentItemButton.Enabled = false;
        } else {
          ContentItemImportIdTextBox.Border = new SolidBrush(Color.Transparent);
          ImportContentItemButton.Enabled = true;
        }
      };
    }

    private void refreshContentItemImportIdTextBox() {
      ContentItemImportIdTextBox.Text = "";
    }

    private void initImportContentItemButton() {
      refreshImportContentItemButton();
      ImportContentItemButton.TouchUp += (sender, args) => {
        var success = ContentItemImporter.Import(ContentItemImportIdTextBox.Text, ContentItemImportSavePathTextBox.Text,
          ContentItemImportPathTextBox.Text,
          Enum.Parse<ContentItemType>(ContentItemImportItemTypeComboBox.SelectedItem.Text));

        if (success) {
          var selectedIndex = ContentItemsList.SelectedIndex;
          refreshUI();
          refreshSpineAssetsComboBox();
          ContentItemsList.SelectedIndex = selectedIndex;
        } else {
          var failDialog = new Window {
            Title = "Import failed",
            Content = new Label {
              Text = "Content item import failed. Check logs for more information."
            }
          };
          failDialog.ShowModal(Desktop);
        }

      };
    }

    private void refreshImportContentItemButton() {
      ImportContentItemButton.Visible = false;
    }

    private void initSkinManagerSettings() {
      refreshSkinManagerSettings();

      StartProjectPathSetCurrentTextButton.TouchUp += (sender, args) => {
        StartProjectPathTextBox.Text = Project.GetActiveProjectPath();
      };

      SaveSkinManagerSettingsTextButton.TouchUp += (sender, args) => {
        Settings.SkinManager.StartProjectPath = StartProjectPathTextBox.Text;
        Settings.SkinManager.StartSpineProjectId = StartSpineProjectIdTextBox.Text;
        Settings.SkinManager.EnableSkins = EnableSkinsTextBox.Text;
        Settings.SkinManager.AssetsPath = AssetsPathTextBox.Text;
        Settings.Save();
      };
    }

    private void refreshSkinManagerSettings() {
      StartProjectPathTextBox.Text = Settings.SkinManager.StartProjectPath;
      StartSpineProjectIdTextBox.Text = Settings.SkinManager.StartSpineProjectId;
      EnableSkinsTextBox.Text = Settings.SkinManager.EnableSkins;
      AssetsPathTextBox.Text = Settings.SkinManager.AssetsPath;
    }

    private void initProjectSettings() {
      refreshProjectSettings();

      SaveCurrentProjectSettingsTextButton.TouchUp += (sender, args) => {
        Project.ProjectConfig.AvailableSidePrefixes = AvailableSidePrefixesTextBox.Text;
        Project.ProjectConfig.AvailableColorChannelSuffixes = AvailableColorChannelSuffixesTextBox.Text;
        Project.ProjectConfig.ImportedSkinDefaultLocation = ImportedSkinDefaultLocationTextBox.Text;
        Project.ProjectConfig.AutoMeshMap = AutoMeshMapTextBox.Text;
        Project.ProjectConfig.MultiSlotMap = MultiSlotMapTextBox.Text;
        Project.ProjectConfig.RefreshAutoMeshMapDictionary();
        Project.SaveProjectConfig();
        refreshUI();
      };
    }

    private void refreshProjectSettings() {
      AvailableSidePrefixesTextBox.Text = Project.ProjectConfig.AvailableSidePrefixes;
      AvailableColorChannelSuffixesTextBox.Text = Project.ProjectConfig.AvailableColorChannelSuffixes;
      ImportedSkinDefaultLocationTextBox.Text = Project.ProjectConfig.ImportedSkinDefaultLocation;
      AutoMeshMapTextBox.Text = Project.ProjectConfig.AutoMeshMap;
      MultiSlotMapTextBox.Text = Project.ProjectConfig.MultiSlotMap;
    }

    private void initProjectPathLabel() {
      refreshProjectPathLabel();
    }

    private void refreshProjectPathLabel() {
      ProjectPathLabel.Text = Project.GetActiveModPath();
    }

    private void initOpenProjectTextButton() {
      OpenProjectTextButton.TouchUp += (sender, args) => {
        var openProjectDialog = new FileDialog(FileDialogMode.ChooseFolder);
        openProjectDialog.Title = "Select folder with MonoPanda project or game";
        openProjectDialog.ShowModal(Desktop);

        openProjectDialog.Closed += (sender, args) => {
          if (openProjectDialog.Result) {
            var path = openProjectDialog.FilePath.Replace("\\", "/");
            if (!path.EndsWith("/")) {
              path += "/";
            }

            Project.OpenProject(path);
            refreshUI();
            refreshSpineAssetsComboBox();
          }
        };
      };
    }

    private void initActiveModComboBox() {
      refreshActiveModComboBox();
      ActiveModComboBoxRefreshButton.TouchUp += (sender, args) => {
        refreshActiveModComboBox();
      };

      ActiveModComboBox.SelectedIndexChanged += (sender, args) => {
        if (ActiveModComboBox.SelectedItem.Text.Equals(Project.ActiveMod)) {
          return;
        }

        Project.SetActiveMod(ActiveModComboBox.SelectedItem.Text);
        refreshUI();
      };
    }

    private void refreshActiveModComboBox() {
      ActiveModComboBox.Items.Clear();
      foreach (string modName in Project.GetMods()) {
        ListItem mod = new ListItem(modName);
        ActiveModComboBox.Items.Add(mod);
      }
      ActiveModComboBox.SelectedItem = ActiveModComboBox.Items.First(item => item.Text.Equals(Project.ActiveMod));
    }

  }
}